;;	SFX for stk1
;;
;;	platform:
;;		i386
;;

%define	sys_virtual_protect			0x0015	;FIXED
%define	sys_virtual_alloc			0x0016	;FIXED


[bits 32]
[org 0x00F00000-0x40]
_DOS_header:
	db "MZ"
	dw (_start_image-_DOS_header),1
	dw 0
	dw 4
	dw -1,-1
	dw 0,0
	dw 0
	dw 0,0
	dw 0x40
	dw 0
	resb 0x20
	dd 0x0E

_header:
	db 0xC3,0x00,0x00
	db "COM64"
	db 0x04,0x01,0x00,0x50
	dd 0
	db 0xC3,"SFX"
	dd _header,_entry
_strmsz	dd 0

_api_gate:
	db "stk1"
_objsz	dd 0

_entry:
	push esi
	mov ah,0x30
	int 0x21
	mov [_api_gate],edx

	mov ebp,[_objsz]

	;;	3 3
	push byte 6
	push byte 1
	mov edi,0x00E00000
	push ebp
	push edi
	push byte sys_virtual_alloc
	pop eax
	call [_api_gate]
	add esp,byte 16
	push edi

	mov esi,_start_image
	add ebp,edi
tdcl010:
		movzx ecx,byte [esi]
		inc esi
		mov ebx,ecx
		and ecx,byte 0x0F
		jnz getlong_by0
			call getnum_s7s
			xchg eax,ecx
getlong_by0:
		shr ebx,4
;		or ebx,ebx
		jnz getlong_lz0
			call getnum_s7s
			xchg eax,ebx
getlong_lz0:
		rep movsb
		cmp edi,ebp
		jae tdcl019
tdcl020:
			movzx edx,byte [esi]
			inc esi
			mov ecx,edx
			and edx,byte 0x0F
			shr edx,1
			jc tdcl022
tdcl021:
					shl edx,8
					mov dl,[esi]
					inc esi
					shr edx,1
				jnc tdcl021
tdcl022:
			shr ecx,4
;			or ecx,ecx
			jnz long_cp0
				call getnum_s7s
				xchg eax,ecx
long_cp0:
			not edx
			inc ecx
tdcl023:
				mov al,[edi+edx]
				stosb
			loop tdcl023
			dec ebx
		jnz tdcl020
	cmp edi,ebp
	jb tdcl010
tdcl019:
fin:
	pop edi

	push dword [edi+0x18]
	movzx ebp,byte [edi+0x09]
	inc ebp
	shl ebp,4
	movzx ebx,byte [edi+0x0A]
	push ebx
	shl ebx,4
	add ebp,edi
	add ebx,ebp
_reloc_elf_loop:
	mov eax,[ebp]
	and eax,byte 7
	jz rel01
	mov ecx,[ebp+0x04]	; memsz
	mov edi,[ebp+0x08]	; base
	push byte 6
	push byte 2
	push ecx
	push edi
	push byte sys_virtual_alloc
	pop eax
	call [_api_gate]
	mov esi,ebx
	mov ecx,[ebp+0x0C]	; filesz
	rep movsb

	mov eax,[ebp]
	and eax,byte 7
	mov ecx,[ebp+0x04]	; memsz
	mov edx,[ebp+0x08]	; base
	push eax
	push ecx
	push edx
	push byte sys_virtual_protect
	pop eax
	call [_api_gate]
	add esp,byte 28
rel01:
	add ebx,[ebp+0x0C]
	add ebp,byte 0x10
	dec dword [esp]
	jnz _reloc_elf_loop
	pop eax
	pop edi
	pop esi
	xor ecx,ecx
	xor edx,edx
	xor ebx,ebx
	xor ebp,ebp
	push byte 32
	pop eax
;	int 3
	jmp edi

getnum_s7s:
	xor eax,eax
gnsl00:
	shl eax,8
	lodsb
	shr eax,1
	jnc gnsl00
	ret

alignb 16
_start_image:
